%Script M-file fit1to1uv for fitting UV data to a 1:2 binding model
clear all; %clears all variables from memory
str = input ('Enter name of input file ','s'); %type in name of datafile to load
load (str); %loads data
C = input ('Enter factor to change htot (usually 1) '); %if it is suspected that host conc.
%is incorrectly determined, here is a change to change it and see if that gives
% better fit. C = factor to change, htot = total concentration of host, C =1
%gives orginal htot.
htot=htot.*C;
initial = [htot Ltot]; %creates a 2 column matrix with the total concentrations
% of the host and ligand to pass on to the fitting functions.
B = input ('Number of iterations to perform (ca. 200 - 1000) ');% how many SIMPLEX iteration are
%done if the solution does not converge.
%Next fout lines calls the user for a initial guess of the parameters to be
%fitted, note that if using previous results it is not a good idea to use them
%unchanged, try changing at least one of the guess by at least from 5-10% for 
%the previously obtained value.  If previous values are used unchanged SIMPLEX
%will probably arrive at the same results whether they represent a local or
%global minima.
%In the following calculation it is assumed that molar absorptivity of the free
%ligand = 0 at the wavelengths under study.
% K11 = the first binding constant (sometimes called K1), K12 = second binding
%constant (sometimes called K2). e11 = Delta(eps) for the 1:1 complex, and 
%e12 Delta(eps) for the 1:2 complex, that is:
%e11 = (molar absorptivity 1:1 complex)-(molar absorptivity host)
%e12 = (molar absorptivity 1:2 complex)-(molar absorptivity host)
E = input ('Enter guess for binding constant = K1, (approx 10 to 1e+5) ');
F = input ('Enter guess for binding constant = K2, (approx 10 to 1e+5) ');

G = input ('Enter guess for DeltadeltaHG for H-1 in = ddHGnmr1, (c.a. 0.1-3 ppm) ');
H = input ('Enter guess for DeltadeltaHG2 for H-1 in = ddHG2nmr1, (c.a. 0.1-3 ppm) ');

I = input ('Enter guess for DeltadeltaHG for H-2 in = ddHGnmr2, (c.a. 0.1-3 ppm) ');
J = input ('Enter guess for DeltadeltaHG2 for H-2 in = ddHG2nmr2, (c.a. 0.1-3 ppm) ');

K = input ('Enter guess for DeltadeltaHG for H-3 in = ddHGnmr3, (c.a. 0.1-3 ppm) ');
L = input ('Enter guess for DeltadeltaHG2 for H-3 in = ddHG2nmr3, (c.a. 0.1-3 ppm) ');

M = input ('Enter guess for DeltadeltaHG for H-4 in = ddHGnmr4, (c.a. 0.1-3 ppm) ');
N = input ('Enter guess for DeltadeltaHG2 for H-4 in = ddHG2nmr4, (c.a. 0.1-3 ppm) ');


%O = input ('Enter guess for Htot factor ');

DAA=DA;
ttb=size(DA);
tt=ttb(1,1);
clear DA;
DA(1:tt,1)=DAA(:,1);
DA(tt+1:tt*2,1)=DAA(:,2);
DA(tt*2+1:tt*3,1)=DAA(:,3);
DA(tt*3+1:tt*4,1)=DAA(:,4);


old=[E F G H I J K L M N];


%E = log(E);
%F = log(F);
%old=[E F H I J K L M N O];

%This stores the initial guesses of Kf, Kb, Def and Deb so they can be called up 
%again later for the final report. 
start1=[E F G H I J K L M N]; %Puts the starting values Kf,Kb,ef and eb in a vector 

options = optimset('Display','final','TolFun',1e-12,'TolX',1e-12,'MaxFunEval',B);
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr1to2para4bnn',start1,options,initial,DA);

%datta=initial;
pererr=100;
y=nmr1to2para1terpyall4chem(results,initial);

%yss=uv2to1para4bcall(finres,datta);
%y=yss;
%Once fminseach finishes the results are displayed:
%Plots the observed values (with *) of DA vs. total conc. of guest on the x-axis.

HH=1;
htot=htot.*HH;
%This extracts the absorbance at added ligand=0, i.e the A in the beginning and 
%assigns it to the constant ff.

htoto=htot(1,:);

ff=DA(1,1);
ffa=DA(tt+1,1);
ttx=tt*2;
tty=tt*3;
ttz=tt*4;

ffb=DA(ttx+1,1);
ffc=DA(tty+1,1);


%This extracts the concentration of the host in the beginning at added ligand = 0
%and assigns it to the constant htoto.

%change:
%fff(:,1)=(htot./htoto).*ff;
%fff(tt+1:tt*2,1)=(htot./htoto).*ffa;

fff(1:tt,1)=ff;
fff(tt+1:ttx,1)=ffa;
fff(ttx+1:tty,1)=ffb;
fff(tty+1:ttz,1)=ffc;

%end of change

%fff(:,3)=(htot./htoto).*ff(1,3);
%fff(:,4)=(htot./htoto).*ff(1,4);

%This adjust the A(0) value for dilution, that is the value of ff is multiplied 
%by total conc. of host at a given point divided with the concentration of the 
%host in the beginning.

DA=(DA-fff); 

%old on; 						%Allows another plot to layered on top of the first one.
%load cc y;						
%Loads the last results of the calculated curve from uvladderb from the temporary
%file cc, that is the calculated curve as it was when fminsearch stopped.

diff = [(DA-y)];

%Calculates the difference between the observed results and the calculated one, 
%i.e. the residual value at each point of the titration

sss=sum(diff.^2);

%calculates the sum of the square of the residual, this is in fact the value 
%which fminsearch was trying to minimize.

ndata=size(DA,1); 			%Number of data points in the experiment.
npara=size(results,2);		%Number of parameters which were fitted.
SE=(sqrt(sss/(ndata-npara))); 

%Calculates the standard error of the y estimate often referred to as RMSD or the
%root-mean-square-deviation, see c.f. E. J. Billo in Excel for Chemist, Wiley-VCH,
%New York, 1997 p. 296.
dev=diff./SE;					%Divides the residuals with the RMSD value.

a=cov(diff); 					%Calculates the covariance of the residual values.
gg=cov(DA);						%Calculates the covariance of the experimental data.
c=a/gg;
xx=Ltot./htot;
%results(1,1)=10^(results(1,1));
%results(1,2)=10^(results(1,2));
subplot(2,1,1) 				%Opens a plotting window with space for two plots.
plot(xx,DA(1:tt),'r*'); 
hold on;
plot(xx,DA(tt+1:2*tt),'b*');
tta=tt*2+1;
ttc=tt*3;
plot(xx,DA(tta:ttc),'k*');
ttb=tt*3+1;
ttd=tt*4;
plot(xx,DA(ttb:ttd),'g*');
plot(xx,y(1:tt),'r');				
plot(xx,y(tt+1:2*tt),'b');
plot(xx,y(tta:ttc),'k');
plot(xx,y(ttb:ttd),'g');

%Plots the calculated curve y vs. total conc. of guest on top of the first plot.

hold off 						%Stops the next plot to be put on top of last plot.

subplot(2,1,2);				%Activates the lower half of the plot window.
plot(xx,dev(1:tt),'r*'); 
hold on;
plot(xx,dev(tt+1:2*tt),'b*');
plot(xx,dev(tta:ttc),'k*');
plot(xx,dev(ttb:ttd),'g*');
hold off

%Plots the deviation plot, see c.f. J.F. Rusling and Thomas F. Kumosinski in 
%Nonlinear Computer Modeling of Chemical and Biochemical Data, Academic Press, 
%San Diego, CA, 1996, p. 13. It should ideally be random.


%Calculates the covariance of residual values/covariance of experimental data, as
%this value gets lower, the better. It is also one of the best values to use to 
%compare the results from different models, e.g. 1:1 vs. 1:2 binding.  Next the
%results from fminsearch are called and the log10 values of Kf and Kb changed 
%back to real numbers.  The last calc. concentrations of free ligand and host are
%also called up from the temporary files LL and HH

%Kf=results(1);					%Calls Kf from results.
%Kb=results(2);					%Calls Kb from results.
%Def=results(3);				%Calls Def from results.
%Deb=results(4);				%Calls Def from results
%Kf=10^Kf;						%Kf changed from log10 base to a real number.
%Kb=10^Kb;						%Kb changed from log10 base to a real number.
%results1=[Kf Kb Def Deb];	%Writes the real number values into results1.
%load LL Lf;						%Loads Lf = calc. conc of free ligand.
%load HH Hf;						%Loads Hf = calc. conc of free host.

%Next the conc. of H2L2 = Ladder and HL2 = 1:2 complex are displayed:

%H2L2 = ((Hf.^2).*(Hf.^2).*Kf)
%HL2 = ((Lf.^2).*(sqrt(Kf.*Kb)).*(Hf))

%The next line creates the heading for displaying the results.



nstor = size(onetwo,1);	

%nstor = the number of iteration experiments previously stored in the result 
%matrix onetwoc = results for this 1:2 model.
%results(1)=exp(results(1));
%results(2)=exp(results(2));
st=nstor+1;						%st = number of experiments which have now been done.
line=[old,results,st,C,sss,SE,pererr,c];

%Gathers in a linear vector called line all the numerical results from this 
%iteration experiment, old = starting values of start1 above, results = results 
%from fminsearch, st = number of iteration experiment done so far, C = factor 
%used to change htot above, sss = sum of squares of residual, SE = RMSD value, 
%c = covariance(fitted data/covariance(experimental data)

if nstor==0;					%This loop is to check if any iteration experiments 
   onetwo=line;
   yall=y;
   %have been done so far, if not (nstor=0) it will make 
else;								%the result matrix ladder = line vector above, 
   onetwo(st,:)=line;
   yall(:,st)=y;
   %otherwise it will add that line vector to the bottom 
end;								%of the result matrix.

						%of the result matrix.

%The next nine lines display the result matrix with the approiate headings, 
%showing the current iteration experiment in the last line.


comm1=['Iteration no'];
comm2=['sum of squares (ss)'];
comm3=['Standard error (SEy)'];
comm4=['covariance of fit'];
comm5=['Inital guess for K1'];
comm6=['Results for K1'];
comm55=['Inital guess for K2'];
comm66=['Results for K2'];


comm7=['Initial guess ddHGnmr1'];
comm8=['Results ddHGnmr1'];
comm9=['Initial guess ddHG2nmr1'];
comm10=['Results ddHG2nmr1'];
comm13=['Initial guess ddHGnmr2'];
comm14=['Results ddHGnmr2'];
comm15=['Initial guess ddHG2nmr2'];
comm16=['Results ddHG2nmr2'];
comm17=['Initial guess ddHGnmr3'];
comm18=['Results ddHGnmr3'];
comm19=['Initial guess ddHG2nmr3'];
comm20=['Results ddHG2nmr3'];
comm21=['Initial guess ddHGnmr4'];
comm22=['Results ddHGnmr4'];
comm23=['Initial guess ddHG2nmr4'];
comm24=['Results ddHG2nmr4'];

%fprintf('\n%s\n %s\n %f\n','All experiments: ',comm7,onetwo(:,2));
fprintf('\n%s\n %s\n %g\n','All experiments: ',comm8,onetwo(:,13));
%fprintf('%s\n %s\n %f\n','All experiments: ',comm9,onetwo(:,3));
fprintf('%s\n %s\n %g\n','All experiments: ',comm10,onetwo(:,14));
fprintf('%s\n %s\n %g\n','All experiments: ',comm14,onetwo(:,15));
fprintf('%s\n %s\n %g\n','All experiments: ',comm16,onetwo(:,16));
fprintf('%s\n %s\n %g\n','All experiments: ',comm18,onetwo(:,17));
fprintf('%s\n %s\n %g\n','All experiments: ',comm20,onetwo(:,18));
fprintf('%s\n %s\n %g\n','All experiments: ',comm22,onetwo(:,19));
fprintf('%s\n %s\n %g\n','All experiments: ',comm22,onetwo(:,20));
%fprintf('%s\n %s\n %f\n','All experiments: ',comm5,onetwo(:,1));
fprintf('%s\n %s\n %g\n','All experiments: ',comm6,onetwo(:,11));
fprintf('%s\n %s\n %g\n','All experiments: ',comm66,onetwo(:,12));


fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm2,onetwo(:,23));
fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm3,onetwo(:,24));
fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm4,onetwo(:,26));

fprintf('\n%s\n %s\t %g\n %s\t %g\n %s\t\t %g\n','Statistics - This experiment: ',comm2,onetwo(st,23),comm3,onetwo(st,24),comm4,onetwo(st,26));




save (str,'onetwo','yall','-append');
[betahat,resid,J] = nlinfit(initial,DA,@nmr1to2para1terpyall4chem,results);
betaci = nlparci(betahat,resid,J);

pererr1 =((results(:)-betaci(:,1))./results(:)).*100;

comm11=['%conf. int. (from asymptotic error): '];

fprintf('\n%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm7,onetwo(st,3),comm8,onetwo(st,13),comm11,pererr1(3));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm9,onetwo(st,4),comm10,onetwo(st,14),comm11,pererr1(4));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm13,onetwo(st,5),comm14,onetwo(st,15),comm11,pererr1(5));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm15,onetwo(st,6),comm16,onetwo(st,16),comm11,pererr1(6));
fprintf('\n%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm17,onetwo(st,7),comm18,onetwo(st,17),comm11,pererr1(7));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm19,onetwo(st,8),comm20,onetwo(st,18),comm11,pererr1(8));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm21,onetwo(st,9),comm22,onetwo(st,19),comm11,pererr1(9));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm23,onetwo(st,10),comm24,onetwo(st,20),comm11,pererr1(10));

fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm5,onetwo(st,1),comm6,onetwo(st,11),comm11,pererr1(1));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm55,onetwo(st,2),comm66,onetwo(st,12),comm11,pererr1(2));


betaci2=betaci;
save (str,'betaci2','-append');