%Script M-file fit1to1uv for fittiall1ng UV data to a 1:2 binding model
clear all; %clears all variables from memory
str = input ('Enter name of input file ','s'); %type in name of datafile to load
load (str); %loads data
C = input ('Enter factor to change htot (usually 1) '); %if it is suspected that host conc.
%is incorrectly determined, here is a change to change it and see if that gives
% better fit. C = factor to change, htot = total concentration of host, C =1
%gives orginal htot.
htot=htot.*C;
initial = [htot Ltot]; %creates a 2 column matrix with the total concentrations
% of the host and ligand to pass on to the fitting functions.
B = input ('Number of iterations to perform (ca. 200 - 1000) ');% how many SIMPLEX iteration are
%done if the solution does not converge.
%Next fout lines calls the user for a initial guess of the parameters to be
%fitted, note that if using previous results it is not a good idea to use them
%unchanged, try changing at least one of the guess by at least from 5-10% for 
%the previously obtained value.  If previous values are used unchanged SIMPLEX
%will probably arrive at the same results whether they represent a local or
%global minima.
%In the following calculation it is assumed that molar absorptivity of the free
%ligand = 0 at the wavelengths under study.
% K11 = the first binding constant (sometimes called K1), K12 = second binding
%constant (sometimes called K2). e11 = Delta(eps) for the 1:1 complex, and 
%e12 Delta(eps) for the 1:2 complex, that is:
%e11 = (molar absorptivity 1:1 complex)-(molar absorptivity host)
%e12 = (molar absorptivity 1:2 complex)-(molar absorptivity host)
E = input ('Enter guess for binding constant = K1, (approx 10 to 1e+5) ');
F = input ('Enter guess for binding constant = K2, (approx 10 to 1e+5) ');

H = input ('Enter guess for epsDeltaHG for wavel.#1 = eDHGuv1, (e.g -10^5 to 10^5) ');
I = input ('Enter guess for epsDeltaHG2 for wavel.#1 = eDHG2uv1, (e.g -10^5 to 10^5) ');



DAA=DA;
%shift ff (at ligand = 0) from the observed chemical shift
ttb=size(DA);
tt=ttb(1,1);
clear DA;
DA(1:tt,1)=DAA(:,1);

old=[E F H I];

%E = log(E);
%F = log(F);
%old=[E F H I J K L M N O];

%This stores the initial guesses of Kf, Kb, Def and Deb so they can be called up 
%again later for the final report. 
start1=[E F H I]; %Puts the starting values Kf,Kb,ef and eb in a vector 

options = optimset('Display','final','TolFun',1e-12,'TolX',1e-12,'MaxFunEval',B);
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('uv1to2para1bnn',start1,options,initial,DA);
%datta=initial;
%finres=results;

pererr=100;
y=uv1to2para1terpyall1chem(results,initial);

%yss=uv2to1para1bcall(finres,datta);
%y=yss;
%Once fminseach finishes the results are displayed:
%Plots the observed values (with *) of DA vs. total conc. of guest on the x-axis.
HH=1;
htot=htot.*HH;
%This extracts the absorbance at added ligand=0, i.e the A in the beginning and 
%assigns it to the constant ff.

htoto=htot(1,:);

ff=DA(1,1);


%This extracts the concentration of the host in the beginning at added ligand = 0
%and assigns it to the constant htoto.

%change:
%fff(:,1)=(htot./htoto).*ff;
%fff(tt+1:tt*2,1)=(htot./htoto).*ffa;

fff(1:tt,1)=ff;

%end of change

%fff(:,3)=(htot./htoto).*ff(1,3);
%fff(:,4)=(htot./htoto).*ff(1,4);

%This adjust the A(0) value for dilution, that is the value of ff is multiplied 
%by total conc. of host at a given point divided with the concentration of the 
%host in the beginning.

DA=(DA-fff); 

%old on; 						%Allows another plot to layered on top of the first one.
%load cc y;						
%Loads the last results of the calculated curve from uvladderb from the temporary
%file cc, that is the calculated curve as it was when fminsearch stopped.

diff = [(DA-y)];

%Calculates the difference between the observed results and the calculated one, 
%i.e. the residual value at each point of the titration

sss=sum(diff.^2);

%calculates the sum of the square of the residual, this is in fact the value 
%which fminsearch was trying to minimize.

ndata=size(DA,1); 			%Number of data points in the experiment.
npara=size(results,2);		%Number of parameters which were fitted.
SE=(sqrt(sss/(ndata-npara))); 

%Calculates the standard error of the y estimate often referred to as RMSD or the
%root-mean-square-deviation, see c.f. E. J. Billo in Excel for Chemist, Wiley-VCH,
%New York, 1997 p. 296.
dev=diff./SE;					%Divides the residuals with the RMSD value.

a=cov(diff); 					%Calculates the covariance of the residual values.
gg=cov(DA);						%Calculates the covariance of the experimental data.
c=a/gg;
xx=Ltot./htot;
%results(1,1)=10^(results(1,1));
%results(1,2)=10^(results(1,2));
subplot(2,1,1) 				%Opens a plotting window with space for two plots.
plot(xx,DA(1:tt),'r*'); 
hold on;

plot(xx,y(1:tt),'r');				

%Plots the calculated curve y vs. total conc. of guest on top of the first plot.

hold off 						%Stops the next plot to be put on top of last plot.

subplot(2,1,2);				%Activates the lower half of the plot window.
plot(xx,dev(1:tt),'r*'); 
hold on;

hold off

%Plots the deviation plot, see c.f. J.F. Rusling and Thomas F. Kumosinski in 
%Nonlinear Computer Modeling of Chemical and Biochemical Data, Academic Press, 
%San Diego, CA, 1996, p. 13. It should ideally be random.


nstor = size(onetwo,1);	

%nstor = the number of iteration experiments previously stored in the result 
%matrix onetwoc = results for this 1:2 model.
%results(1)=exp(results(1));
%results(2)=exp(results(2));
st=nstor+1;						%st = number of experiments which have now been done.
line=[old,results,st,C,sss,SE,pererr,c];

%Gathers in a linear vector called line all the numerical results from this 
%iteration experiment, old = starting values of start1 above, results = results 
%from fminsearch, st = number of iteration experiment done so far, C = factor 
%used to change htot above, sss = sum of squares of residual, SE = RMSD value, 
%c = covariance(fitted data/covariance(experimental data)

if nstor==0;					%This loop is to check if any iteration experiments 
   onetwo=line;
   yall=y;
   %have been done so far, if not (nstor=0) it will make 
else;								%the result matrix ladder = line vector above, 
   onetwo(st,:)=line;
   yall(:,st)=y;
   %otherwise it will add that line vector to the bottom 
end;								%of the result matrix.

						%of the result matrix.

%The next nine lines display the result matrix with the approiate headings, 
%showing the current iteration experiment in the last line.

comm1=['Iteration no'];
comm2=['sum of squares (ss)'];
comm3=['Standard error (SEy)'];
comm4=['covariance of fit'];
comm5=['Inital guess for K1'];
comm6=['Results for K1'];
comm55=['Inital guess for K2'];
comm66=['Results for K2'];


comm7=['Initial guess eDHGuv1'];
comm8=['Results eDHGuv1'];
comm9=['Initial guess eDHG2uv1'];
comm10=['Results eDHG2uv1'];


%fprintf('\n%s\n %s\n %f\n','All experiments: ',comm7,onetwo(:,2));
fprintf('\n%s\n %s\n %g\n','All experiments: ',comm8,onetwo(:,7));
%fprintf('%s\n %s\n %f\n','All experiments: ',comm9,onetwo(:,3));
fprintf('%s\n %s\n %g\n','All experiments: ',comm10,onetwo(:,8));

%fprintf('%s\n %s\n %f\n','All experiments: ',comm5,onetwo(:,1));
fprintf('%s\n %s\n %g\n','All experiments: ',comm6,onetwo(:,5));
fprintf('%s\n %s\n %g\n','All experiments: ',comm66,onetwo(:,6));


fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm2,onetwo(:,11));
fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm3,onetwo(:,12));
fprintf('%s\n %s\n %g\n','Statistics - All experiments: ',comm4,onetwo(:,14));

fprintf('\n%s\n %s\t %g\n %s\t %g\n %s\t\t %g\n','Statistics - This experiment: ',comm2,onetwo(st,11),comm3,onetwo(st,12),comm4,onetwo(st,14));




save (str,'onetwo','yall','-append');
[betahat,resid,J] = nlinfit(initial,DA,@uv1to2para1terpyall1chem,results);
betaci = nlparci(betahat,resid,J);
pererr1 =((results(:)-betaci(:,1))./results(:)).*100;

comm11=['%conf. int. (from asymptotic error): '];

fprintf('\n%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm7,onetwo(st,3),comm8,onetwo(st,7),comm11,pererr1(3));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm9,onetwo(st,4),comm10,onetwo(st,8),comm11,pererr1(4));

fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm5,onetwo(st,1),comm6,onetwo(st,5),comm11,pererr1(1));
fprintf('%s\n %s\t\t\t\t\t\t %g\n %s\t\t\t\t\t\t\t %g\n %s %4.1f\n\n','This experiment: ',comm55,onetwo(st,2),comm66,onetwo(st,6),comm11,pererr1(2));

betaci2=betaci;
save (str,'betaci2','-append');
