%Script M-file fit2to1uv for fitting UV data to a 1:2 binding model
clear all; %clears all variables from memory

fprintf('\n%s\n','This is a simulation program for 2:1 Equilibria by nmr-Vis');
str = input ('Enter name of file to save results ','s'); %type in name of datafile to load
%load (str); %loads data

% of the host and ligand to pass on to the fitting functions.
B = input ('Number of iterations to perform per cycle (e.g., 200-1000) ');% how many SIMPLEX iteration are
BB = input ('Number of cycles (e.g. 10-50 - can be timeconsuming!) ');% how many SIMPLEX iteration are
%done if the solution does not converge.
%Next fout lines calls the user for a initial guess of the parameters to be

%e12 = (molar absorptivity 1:2 complex)-(molar absorptivity host)
E = input ('Enter guess for binding constant = K1, (approx. 10 to 1e+5) ');
EE = input ('Enter guess for binding constant = K2, (approx. 10 to 1e+5) ');
F = input ('Enter guess for DeltadeltaHG for H-1 in = ddHGnmr1, (c.a. 0.1-3 ppm) ');
G = input ('Enter guess for DeltadeltaH2G for H-1 in = ddH2Gnmr1, (c.a. 0.1-3 ppm) ');


%O = input ('Enter guess for Htot factor ');


H = input ('Enter % error on DA data (e.g., 2%) ');
I = input ('Enter % error on htot data (e.g., 1%) ');
K = input ('Enter % error on Ltot data (e.g, 1%) ');

K1 = input ('starting total host conc. (Ho) (e.g., 1e-5) ');
M = input ('final eq. ligand added (e.g, 20) ');
Ltot=[0:0.1:M]';
KK=size(Ltot,1);
htot=ones(KK,1);
htot=htot.*K1;
Ltot=htot.*Ltot;
errorvect=[H I K K1 M];


H=H./100;
I=I./100;
K=K./100;

sizeofDA=size(Ltot,1);
DAerror=1+(H.*randn(sizeofDA,BB));
htoterror=1+(I.*randn(1,BB));
Ltoterror=1+(K.*randn(1,BB));
Ltoterror(1,1)=1;
htoterror(1,1)=1;
DAerror(:,1)=ones;
DAerror=DAerror.*(1+(H.*randn(1,1)));
ttb=size(Ltot);
tt=ttb(1,1);

results=[E EE F G];
initial=[htot Ltot];
y=nmr2to1para1terpyall1chem(results,initial);
DAA=y;

old=[E EE F G];
%i=BB;
for i=1:BB;
    te=i.*2;
    to=te-1;
    initial=[htot.*htoterror(1,i) Ltot.*Ltoterror(1,i)];
    DA=DAA.*DAerror(:,i);
start1=[E EE F G]; %Puts the starting values Kf,Kb,ef and eb in a vector 

options = optimset('Display','final','TolFun',1e-12,'TolX',1e-12,'MaxFunEval',B);
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
start1=results;
results=fminsearch('nmr2to1para1bnn',start1,options,initial,DA);
initialall(:,to)=initial(:,1);
initialall(:,te)=initial(:,2);
resultsall(i,:)=results;
yall(:,i)=nmr2to1para1terpyall1chem(resultsall(i,:),initialall(:,to:te));
%datta=initial;
%finres=results;
[betahat,resid,J] = nlinfit(initial,DA,@nmr2to1para1terpyall1chem,results);
betaci = nlparci(betahat,resid,J);
betastuff(:,i)=betaci(:,1);
pererr(:,i)=((results(1)-betaci(1,1))./results(1)).*100;
end
noerrorres=resultsall(1,:);
perspace=prctile(resultsall,[2.5 97.5]);


lowstdres=noerrorres;
lowstdres(:,1)=perspace(1,1);
highstdres=noerrorres;
highstdres(:,1)=perspace(2,1);
initial=[htot Ltot];
results=lowstdres;

ylow=nmr2to1para1terpyall1chem(results,initial);
results=highstdres;
yhigh=nmr2to1para1terpyall1chem(results,initial);
ylow(1,1)=0;
yhigh(1,1)=0;
xx=(Ltot*Ltoterror)./(htot*htoterror);
%results(1,1)=10^(results(1,1));
%results(1,2)=10^(results(1,2));

plot(xx(:,1),yall(:,1),'k','LineWidth',2); 
hold on;
plot(xx(:,2:end),yall(:,2:end),'b*'); 
plot(xx(:,1),DAA,'r*');				
plot(xx(:,1),ylow,'b','LineWidth',2);				
plot(xx(:,1),yhigh,'b','LineWidth',2);		
%Plots the calculated curve y vs. total conc. of guest on top of the first plot.

hold off 						%Stops the next plot to be put on top of last plot.

comm6=['Results for K1'];

comm66=['Results for K2'];

comm8=['Results ddHGnmr1'];

comm10=['Results ddH2Gnmr1'];




comm11=['%lower conf. int. (from Monte Carlo): '];
comm12=['%higher conf. int. (from Monte Carlo): '];

fprintf('\n%s\n %s\t\t\t\t\t\t %g\n\n %s %g','This experiment: ',comm8,resultsall(1,3),comm11,perspace(1,3));
fprintf('\n%s %g\n',comm12,perspace(2,3));
fprintf('\n%s\n %s\t\t\t\t\t\t %g\n\n %s %g','This experiment: ',comm10,resultsall(1,4),comm11,perspace(1,4));
fprintf('\n%s %g\n',comm12,perspace(2,4));


fprintf('\n%s\n %s\t\t\t\t\t\t %g\n\n %s %g','This experiment: ',comm6,resultsall(1,1),comm11,perspace(1,1));
fprintf('\n%s %g\n',comm12,perspace(2,1));

fprintf('\n%s\n %s\t\t\t\t\t\t %g\n\n %s %g','This experiment: ',comm66,resultsall(1,2),comm11,perspace(1,2));
fprintf('\n%s %g\n',comm12,perspace(2,2));

save (str,'noerrorres','resultsall','perspace','yall','htot','Ltot','DAA','ylow','yhigh','errorvect');
%Adds the results matrix to the data file in use. End of function.
